local f = CreateFrame("Frame", "SacriRaidBuffed", UIParent)


-- CONFIG --
f.fd = 26			-- Icon size			/ Dimensione dell'icona
f.gap = 3			-- Icon spacing			/ Spaziatura tra le icone
f.okA = 1			-- Icon Alpha buff on	/ Visibilit dell'icona con buff presente
f.koA = 0.2			-- Icon Alpha buff off	/ Visibilit icon con buff assente
f.vert = false		-- True = vertical alignment (column), False = horizontal alignment (row)	/ True dispone le icone in verticale, False in orizzontale
f.sd = true			-- True = When hovering an icon shows a tooltip stating a description for the buff; Shows "Stats" when hovering Kings/MotW buff
					-- True per mostrare la funzione del buff quando passi il mouse sull'icona
					
f.foodflask = true	-- True: Shows 2 additional icons to check well fed and flask		/ True: mostra 2 icone in pi per monitorare cibo e flask

-- Icon style
-- If you are using http://www.wowinterface.com/downloads/info19844-CleanIcons-Thin.html or a similiar addon you may want to set f.usingcustomicons = true to prevent cropping the icon border
-- Se stai usando http://www.wowinterface.com/downloads/info19844-CleanIcons-Thin.html o un addon simile potresti voler settare f.usingcustomicons = true in modo da non tagliare i bordi delle icone
f.usingcustomicons = false

f.desaturate = true	--true: make the icons Gray instead of faded out	// true: fai diventare le icone grigie invece che semitrasparenti

-- Visibility
f.showifalone = true	--True: always show the icons; false: show the icons only if in a group	// True: mostra sempre le icone; false: mostra le icone solo se in gruppo


--Positioning: In Game Method/ Posizionamento: Metodo in gioco
f.userplaced = false	--True = Use ingame positioning method; False: Use lua method	/ True: Usa posizionamento in game; False: Usa metodo lua

--Positioning: ingame method														/ Posizionamento: metodo in gioco
-- To unlock the frame ingame write /srb unlock										/ Per sbloccare il frame scrivere /srb unlock
-- To lock the frame write /srb lock												/ Per bloccarlo scrivere /srb lock


--Positioning: Lua Method															/ Posizionamento: Metodo Lua
					-- Anchor														/ Ancora
f.fp = "TOPRIGHT"	-- this point of the frame										/ questo punto del frame
f.sp = "TOPRIGHT"	-- to this point of												/ a questo punto
f.rel = UIParent	-- this frame (UIParent means the whole screen)					/ di questo frame

f.x = -10			-- horizontal offset; +1 goes right, -1 goes left				/ a questa distanza orizzontale, +1 va verso destra, -1 verso sinistra
f.y = -10			-- vertical offeset; +1 goes up, -1 goes down					/ a questa distanza verticale, +1 va verso sopra, -1 verso sotto
-- /CONFIG --

-- DO NOT EDIT BELOW	/ Non modificare oltre
-- if you don't know what you're doing :D	/ se non sai cosa stai facendo
--[[
	Buff List
	http://www.wowhead.com/guide=1100
]]--
local applyDragFunctionality = function(f,userplaced,locked)
	f:SetScript("OnDragStart", function(s) if IsShiftKeyDown() then s:StartMoving() end end)
	f:SetScript("OnDragStop", function(s) s:StopMovingOrSizing() end)

	local t = f:CreateTexture(nil,"OVERLAY",nil,6)
	t:SetAllPoints(f)
	t:SetTexture(0,1,0)
	t:SetAlpha(0)
	f.dragtexture = t    
	f:SetHitRectInsets(-50,-50, -50, -50)
	--f:SetClampedToScreen(true)

	if not userplaced then
		f:SetMovable(false)
	else
		f:SetMovable(true)
		f:SetUserPlaced(true)
		if not locked then
			f.dragtexture:SetAlpha(0.2)
			f:EnableMouse(true)
			f:RegisterForDrag("LeftButton")
			f:SetScript("OnEnter", function(s) 
				GameTooltip:SetOwner(s, "ANCHOR_TOP")
				GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
				GameTooltip:AddLine("Hold down ALT+SHIFT to drag!", 1, 1, 1, 1, 1, 1)
				GameTooltip:Show()
				end)
			f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
		else
			f.dragtexture:SetAlpha(0)
			f:EnableMouse(nil)
			f:RegisterForDrag(nil)
			f:SetScript("OnEnter", nil)
			f:SetScript("OnLeave", nil)
		end
	end  
end
applyDragFunctionality(f, f.userplaced, true)
  
  
local GetRaidBuffTrayAuraInfo = GetRaidBuffTrayAuraInfo

if f.foodflask then
	f.n = NUM_LE_RAID_BUFF_TYPES +2
else
	f.n = NUM_LE_RAID_BUFF_TYPES
end

if f.vert then
	f:SetHeight(f.n * (f.fd+f.gap) + 2*f.gap)
	f:SetWidth(f.fd+f.gap*2)
else
	f:SetWidth(f.n * (f.fd+f.gap) + 2*f.gap)
	f:SetHeight(f.fd+f.gap*2)
end


f:SetPoint(f.fp, f.rel, f.sp, f.x, f.y)


local function cap(str)
    return (str:gsub("^%l", string.upper))
end

do
	f.Locale = LibStub("LibBabble-TalentTree-3.0"):GetLookupTable()
	f.classes = {}
	local numClasses = GetNumClasses();
	local classDisplayName, classTag
	for i = 1, numClasses do
		--[[
		Warrior WARRIOR 1
		Paladin PALADIN 2
		Hunter HUNTER 3
		Rogue ROGUE 4
		Priest PRIEST 5
		Death Knight DEATHKNIGHT 6
		Shaman SHAMAN 7
		Mage MAGE 8
		Warlock WARLOCK 9
		Monk MONK 10
		Druid DRUID 11
		]]--
		classDisplayName, classTag = GetClassInfo(i);
		f.classes[classTag] = classDisplayName			
	end
end

function f:CreateButton(i)

	local btn = CreateFrame("Frame", "SRB"..i, f)
	
	local any = cap(SPELL_TARGET_TYPE1_DESC)
	local pet = cap(PET)
	
	local strany = "%s %s"				-- Any DRUID
	local strpet = "%s %s (%s: %s)"		-- Any WARLOCK (Pet: Imp)
	local bm = f.classes["HUNTER"]..": "..f.Locale["Beast Mastery"].." ("..pet..": ".."%s)"
	local str1spec = "%s: %s"			-- Shaman: Enhancement
	local str2spec = "%s: %s, %s"		-- DK: frost, unholy
	if i == 1 then
		btn.bt =  "Interface\\ICONS\\spell_magic_greaterblessingofkings"
		btn.desc = RAID_BUFF_1 --"Stats"
		btn.given = {
			-- "Any Druid",
			-- "Any Paladin",
			-- "Any Monk"
			strany:format(any, f.classes["PALADIN"]),
			strany:format(any, f.classes["DRUID"]),
			strany:format(any, f.classes["MONK"]),
			bm:format("Shale Spider"),
		}
	elseif i == 2 then
		btn.bt = "Interface\\ICONS\\spell_holy_wordfortitude"
		btn.desc = RAID_BUFF_2 --"Stamina"
		btn.given = {
			-- "Any Priest",
			-- "Any Warlock (Imp)",
			-- "Any Warrior"
			strany:format(any, f.classes["PRIEST"]),
			strpet:format(any, f.classes["WARLOCK"], pet, (GetSpellInfo(688))),
			strany:format(any, f.classes["WARRIOR"]),
			bm:format("Silithid"),
		}
	elseif i == 3 then
		btn.bt = "Interface\\ICONS\\ability_warrior_battleshout"
		btn.desc = RAID_BUFF_3 --"Attack Power"
		btn.given = {
			-- "Any Death Knight",
			-- "Any Hunter",
			-- "Any Warrior"
			strany:format(any, f.classes["DEATHKNIGHT"]),
			strany:format(any, f.classes["HUNTER"]),
			strany:format(any, f.classes["WARRIOR"]),
			
		}
	elseif i == 4 then
		btn.bt = "Interface\\ICONS\\ability_rogue_disembowel"
		btn.desc = RAID_BUFF_4 --"Attack Speed"
		btn.given = {
			-- "Frost and Unholy Death Knights",
			-- "Any Rogue",
			-- "Enhancement Shamans"
			str2spec:format(f.classes["DEATHKNIGHT"], f.Locale["Frost"], f.Locale["Unholy"]),
			strany:format(any, f.classes["ROGUE"]),
			str1spec:format(f.classes["SHAMAN"], f.Locale["Enhancement"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Hyena, Serpent"),
		}		
	elseif i == 5 then
		btn.bt = "Interface\\ICONS\\spell_fire_totemofwrath"
		btn.desc = RAID_BUFF_5 --"Spell Power"
		btn.given = {
			-- "Any Mage",
			-- "Any Shaman",
			-- "Any Warlock"
			strany:format(any, f.classes["MAGE"]),
			strany:format(any, f.classes["SHAMAN"]),
			strany:format(any, f.classes["WARLOCK"]),
			bm:format("Waterstrider"),
		}
	elseif i == 6 then
		btn.bt = "Interface\\ICONS\\spell_nature_moonglow"
		btn.desc = RAID_BUFF_6--"Spell Haste"
		btn.given = {
			-- "Balance Druids", 
			-- "Shadow Priest",
			-- "Elemental Shamans"
			str1spec:format(f.classes["DRUID"], f.Locale["Balance"]),
			str1spec:format(f.classes["PRIEST"], f.Locale["Shadow"]),
			str1spec:format(f.classes["SHAMAN"], f.Locale["Elemental"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Sporebat"),
		}
	elseif i == 7 then
		btn.bt = "Interface\\ICONS\\spell_nature_unyeildingstamina"
		btn.desc = RAID_BUFF_7--"Critical Strike"
		btn.given = {
			-- "Guardian and Feral Druids",
			-- "Windwalker Monks",
			-- "Any Mage"
			str2spec:format(f.classes["DRUID"], f.Locale["Guardian"], f.Locale["Feral"]),
			str1spec:format(f.classes["MONK"], f.Locale["Windwalker"]),
			strany:format(any, f.classes["MAGE"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Hydra, Wolf"),
			bm:format("Devilsaur, Quilen, Waterstrider"),
		}
	elseif i == 8 then
		btn.bt = "Interface\\ICONS\\spell_holy_greaterblessingofkings"
		btn.desc = RAID_BUFF_8--"Mastery"
		btn.given = {
			-- "Any Paladin",
			-- "Any Shaman"
			strany:format(any, f.classes["PALADIN"]),
			strany:format(any, f.classes["SHAMAN"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Cat"),
			bm:format("Spirit Beast"),
		}
	elseif i == 9 then
		btn.bt = "Interface\\ICONS\\spell_misc_food"
		btn.desc = (GetSpellInfo(104267))
		btn.given = {
			POWER_TYPE_FOOD
		}
	elseif i == 10 then
		btn.bt = "Interface\\ICONS\\trade_alchemy_potione5"
		btn.desc = (select(4, GetAuctionItemSubClasses(4))) --"Flask"
		btn.given = {
			(select(4, GetAuctionItemSubClasses(4))),
		}
	end
	
	if f.sd then
	
		btn:SetScript("OnEnter", function(self) 
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
				GameTooltip:ClearLines()
				GameTooltip:AddLine(self.desc)
				for i = 1, #btn.given do
					GameTooltip:AddLine(btn.given[i])
				end
				GameTooltip:Show()
			end)
			
		btn:SetScript("OnLeave", function(self) 
				GameTooltip:Hide()
			end)
	
	end
	
	btn:SetHeight(f.fd)
	btn:SetWidth(f.fd)
	btn.bg = btn:CreateTexture(nil, "BACKGROUND")
	btn.bg:SetAllPoints(btn)
	btn.bg:SetTexture(btn.bt)
	
	if not f.usingcustomicons then
		btn.bg:SetTexCoord(.08, .92, .08, .92)
	end
	
	btn:SetAlpha(f.koA)
	btn:Show()
	
	if f.desaturate then
		f.okA = 1
		f.koA = 0
		btn:SetAlpha(f.okA)
		btn.SetAlpha = function(self, n)
			if n == 1 then 
				n = false 
			else 
				n = true
			end
			self.bg:SetDesaturated(n)
		end
	end
	
	return btn
end	

function f:GROUP_ROSTER_UPDATE()
	if GetNumGroupMembers() == 0 then
		f:Hide()
	else
		f:Show()
	end
end

function f:ADDON_LOADED(event, arg1, ...)

	if arg1 == "SacriRaidBuffed" then
		

		f:UnregisterEvent("ADDON_LOADED");

		for i=1,f.n do
		
			f[i] = f:CreateButton(i)
			
			if f.vert then
				if i == 1 then
					f[i]:SetPoint("TOP", f, "TOP", 0, f.gap)
				else
					f[i]:SetPoint("TOP", f[i-1], "BOTTOM", 0, f.gap)
				end
			else
				if i == 1 then
					f[i]:SetPoint("RIGHT", f , "RIGHT", -f.gap, 0)
				else
					f[i]:SetPoint("RIGHT", f[i-1], "LEFT", -f.gap, 0)
				end
			end
		end

		f:Show()
		if f.showifalone == false then
			f:GROUP_ROSTER_UPDATE()
		end

	end

end


function f:CheckFlask()

	local _, texture
	
	local flasks = {105693, 105689, 105691, 105694, 105696} --, 79472 }
	for i = 1, #flasks do
		local name =(GetSpellInfo(flasks[i]))
		_, _, texture = UnitBuff("Player", name)
		if texture then
			return texture
		end
	end
	return nil
end

function f:FixHunterMasteryBuffs()
	local i = NUM_LE_RAID_BUFF_TYPES
	
	if f[i]:GetAlpha() == f.okA then
		return
	else
		local name, _, texture = UnitBuff("Player", (GetSpellInfo(93435)))
		if name then 	
			f[i].bg:SetTexture(texture)
			f[i]:SetAlpha(f.okA)
			return
		end
		
		name, _, texture = UnitBuff("Player", (GetSpellInfo(128997)))
		if name then 	
			f[i].bg:SetTexture(texture)
			f[i]:SetAlpha(f.okA)
			return
		end
		
		f[i]:SetAlpha(f.koA)
	end

end


function f:PLAYER_AURAS_CHANGED()

	for i=1,NUM_LE_RAID_BUFF_TYPES do
		local name, _, texture = GetRaidBuffTrayAuraInfo(i);
		
		if name then 	
			f[i].bg:SetTexture(texture)
			f[i]:SetAlpha(f.okA)
		else
			f[i]:SetAlpha(f.koA)
		end
	end
	
	f:FixHunterMasteryBuffs()
	
	if f.foodflask then
		local _, _, texture = UnitBuff("Player", (GetSpellInfo(104267)))
		if texture then
			f[NUM_LE_RAID_BUFF_TYPES+1].bg:SetTexture(texture)
			f[NUM_LE_RAID_BUFF_TYPES+1]:SetAlpha(f.okA)
		else
			f[NUM_LE_RAID_BUFF_TYPES+1]:SetAlpha(f.koA)
		end
		
		local flasked = f:CheckFlask()
		if flasked then
			f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetTexture(flasked)
			f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(f.okA)
		else
			f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(f.koA)
		end
	end
	
end

function f:PLAYER_ENTERING_WORLD()
	--SetCVar("consolidateBuffs", 1)
	
	hooksecurefunc(ConsolidatedBuffs, "Show", function() 
		--print("Hiding ConsolidatedBuffs Button")
		ConsolidatedBuffs:Hide()
		end)
		
	f:PLAYER_AURAS_CHANGED()
end

function f:UNIT_AURA(event, ...)
	f:PLAYER_AURAS_CHANGED()
end

function f:PLAYER_UNGHOST()
	f:PLAYER_AURAS_CHANGED()
end

function f:unlockFrame()
	print("Frames unlocked")
	print("/srb lock to lock")
	
	if f and f:IsUserPlaced() then
		if f.showifalone == false then
			if not f:IsVisible() then
				f:Show()
			end
		end
		--print(f:GetName())
		f.dragtexture:SetAlpha(0.2)
		f:EnableMouse(true)
		f:RegisterForDrag("LeftButton")
		
		f:SetScript("OnEnter", function(s) 
		GameTooltip:SetOwner(s, "ANCHOR_TOP")
		GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
		GameTooltip:AddLine("Hold down SHIFT to drag!", 1, 1, 1, 1, 1, 1)
		GameTooltip:Show()
		end)
		f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
	end
end  
  
function f:lockFrame()
	print("Frames locked")
	print("/srb unlock to unlock")
	if f and f:IsUserPlaced() then
		if f.showifalone == false then
			if f:IsVisible() then
				f:Hide()
			end
		end
		f.dragtexture:SetAlpha(0)
		f:EnableMouse(nil)
		f:RegisterForDrag(nil)
		f:SetScript("OnEnter", nil)
		f:SetScript("OnLeave", nil)
	end
end

function SacriRaidBuffed_slashHandler(arg1)
	print("SacriRaidBuffed is running")
	print("Options")
	print("/srb unlock")
	print("/srb lock")
	
	if f.userplaced then
		if arg1 == "lock" then
			f:lockFrame()
		elseif arg1 == "unlock" then
			f:unlockFrame()
		end
	else
		if arg1 == "lock" then
			print("Set f.userplaced true first")
		elseif arg1 == "unlock" then
			print("Set f.userplaced true first")
		end
	end
	--[[
	if arg1 ~= "" then
		ConsolidatedBuffsTooltip:Show()
	else
		ConsolidatedBuffsTooltip:Hide()
	end
	]]--
end

--[[
function f:CVAR_UPDATE(event, cvar, value)
	if cvar == "CONSOLIDATE_BUFFS_TEXT" and value ~= 1 then
		SetCVar("consolidateBuffs", 1)
	end
end
]]--

SlashCmdList["SacriRaidBuffed"] = SacriRaidBuffed_slashHandler
SLASH_SacriRaidBuffed1 = "/srb"

f:RegisterUnitEvent("ADDON_LOADED", "Player");
f:RegisterUnitEvent("UNIT_AURA", "Player");
f:RegisterUnitEvent("PLAYER_ENTERING_WORLD", "Player");
f:RegisterUnitEvent("PLAYER_AURAS_CHANGED", "Player");
f:RegisterUnitEvent("PLAYER_UNGHOST", "Player");
--f:RegisterUnitEvent("CVAR_UPDATE");

if f.showifalone == false then
	f:RegisterEvent("GROUP_ROSTER_UPDATE")
end
f:SetScript('OnEvent', function(self, event, ...) self[event](self, event, ...) end)